/*  Ec      Copyright (C)   2001 Marc Dechico

    ec_defin.i : most of the define needed by the application 
    
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    

*/

/* Contient la pluspart des define sauf qq taille de tableau */ 





#if BORLAND_C == 1
#include 	<sys/timeb.h>
#if DOS == 1
#include <bios.h>
#endif
#else
#include 	<sys/time.h>
#endif

/* directive  compilateur */
 
/* #define BORLAND_C   0 */			/* 0 = Non 1 = OUI */
/*#define GCC	    1 */
 

#if BORLAND_C == 1
#if DOS == 1
#define ESC 27
#endif
#endif

#if LINUX  == 1
const struct sigaction st_sig_act;	/* gestion message system */ 
#endif

/* directive conditionelle por debug */
# define CPT_ITE 0		/* 1 pour inclusion du code 0 sinon */
# define CTL_DEP_ECH_PIE 0	/*  pour controle dephasage entre echiquier et piece */ 

/* Length of the full-path-file-name for save and restor */
#define LEN_FUL_PAT_FIL_NAM 100

/* Longueur message utilisateur */
#define LEN_MES 200

/* Nombre de parametre a inclure dans messages */
#define NBR_MAX_PAR_MES 10
/* Longueur maximum du parametre */
#define LON_MAX_PAR_MES 80

/* Profondeur de hst_pro */
#define PRO_HST			300
/* Nombre maximum de mouvement initiaux */
#define MVT_INI			70

/* Profondeur maximum de simulation inferieur/superieur */
#define PRO_SIM_SUP_MAX 10
#define PRO_SIM_INF_MAX 16

/* type de rock */
#define PET_ROC			0
#define GRA_ROC 		1

/* Valeur possible pour  le camp */
#define BLANC			0
#define NOIR    		1
#define VIDE                   -1
#define HOR_ECH                -2

/* Type de mouvements */
#define PAS_DE_MVT		0
/* cavalier tour fou reine  */
#define TFR_DEP			1
#define TFR_PRI			2
/* roi */
#define ROI_DEP			3
#define ROI_PRI		        4
#define ROI_GRA_ROC		5
#define ROI_PET_ROC		6
/* cavalier */
#define CAV_DEP			7
#define CAV_PRI			8
/* pion */
#define PIO_1C        		9
#define PIO_2C 	       		10
#define PIO_PRI			11
#define PIO_PRI_PAS		12

#define PIO_PRO_REI	        13
#define PIO_PRO_FOU	        14
#define PIO_PRO_TOU	        15
#define PIO_PRO_CAV	        16

#define PIO_PRO_REI_PRI	        17
#define PIO_PRO_FOU_PRI	        18
#define PIO_PRO_TOU_PRI	        19
#define PIO_PRO_CAV_PRI	        20

#define NBR_TYP_MVT             21

/* */
#define NOT_MIN        -32768    /* le plus grand nombre negatif pour le type int */
#define NOT_ROC_TOU      -1    /* empecher le roc  */

#define FOR_PIO           10
#define FOR_CAV           30
#define FOR_FOU           50
#define FOR_TOU           70
#define FOR_REI          200
#define FOR_ROI            1     /* pour analyse couverture */

/* opti: cette valeur devrait tre ramen  force piece origine 
   dans le cas d'une forte superiorie */
#define FOR_INC_PIO           10
#define FOR_INC_CAV           41
#define FOR_INC_FOU           81
#define FOR_INC_TOU          121
#define FOR_INC_REI          281
#define FOR_INC_ROI            1     

#define NOT_MAT              500

/* libelle colone <-> N de colonne */
#define A              1
#define B              2
#define C              3
#define D              4
#define E              5
#define F              6
#define G              7
#define H              8

/* libelle case <-> numro de case  */
#define A1              11
#define A2              21 
#define A3              31
#define A4              41
#define A5              51
#define A6              61
#define A7              71
#define A8              81

#define B1              12
#define B2              22
#define B3              32
#define B4              42
#define B5              52
#define B6              62
#define B7              72
#define B8              82

#define C1              13
#define C2              23
#define C3              33
#define C4              43
#define C5              53
#define C6              63
#define C7              73
#define C8              83

#define D1              14
#define D2              24
#define D3              34
#define D4              44
#define D5              54
#define D6              64
#define D7              74
#define D8              84

#define E1              15
#define E2              25
#define E3              35
#define E4              45
#define E5              55
#define E6              65
#define E7              75
#define E8              85

#define F1              16
#define F2              26
#define F3              36
#define F4              46
#define F5              56
#define F6              66
#define F7              76
#define F8              86

#define G1              17
#define G2              27
#define G3              37
#define G4              47
#define G5              57
#define G6              67
#define G7              77
#define G8              87

#define H1              18
#define H2              28
#define H3              38
#define H4              48
#define H5              58
#define H6              68
#define H7              78
#define H8              88

/* Modification de coordonne roi, reine, fou, tour */
#define HH             +=10              /* haut        1 case */
#define HD             +=11              /* haut droite 1 case */
#define DD             +=1               /* droite      1 case */
#define BD             -=9               /* bas droite  1 case */
#define BB             -=10              /* bas         1 case */
#define BG             -=11              /* bas gauche  1 case */
#define GG             -=1               /* gauche      1 case */
#define HG             +=9               /* haut gauche 1 case */

#define _HH             +=10              /* haut        1 case */
#define _HD             +=11              /* haut droite 1 case */
#define _DD             +=1               /* droite      1 case */
#define _BD             -=9               /* bas droite  1 case */
#define _BB             -=10              /* bas         1 case */
#define _BG             -=11              /* bas gauche  1 case */
#define _GG             -=1               /* gauche      1 case */
#define _HG             +=9               /* haut gauche 1 case */


/* Modification de coordonne cavalier */
#define CHD             +=21              /* cavalier haut droite */
#define CDH             +=12              /* cavalier droite haut */
#define CDB             -=8               /* cavalier droite bas  */
#define CBD             -=19              /* cavalier bas droite  */
#define CBG             -=21              /* cavalier bas gauche  */
#define CGB             -=12              /* cavalier gauche bas  */
#define CGH             +=8               /* cavalier gauche haut */
#define CHG             +=19              /* cavalier haut gauche */

/* Modification de coordonne pion blanc */
#define PH1            +=10              /* pion haut 1        */
#define PH2            +=20              /* pion haut 2        */
#define PHG            +=9               /* pion haut gauche   */
#define PHD            +=11              /* pion haut droite   */

#define PB1            -=10              /* pion bas 1         */
#define PB2            -=20              /* pion bas 2         */
#define PBG            -=11              /* pion bas gauche    */
#define PBD            -=9               /* pion bas droite    */

/* Version alternative: efficience non prouve */
#define ROC_NV  0    /* 0 ne pas utilise */

/* Message d'erreur */
enum e_msg_nbr 
{
      MSG_CHA_MES_LON_MSG		,
      MSG_CHO_COT_INV			,
      MSG_CHO_INC_INV			,
      MSG_CHO_NIV_INC_INV		,
      MSG_CHO_NIV_INV			,
      MSG_EXI_MVT_INI_NON		,
      MSG_JOU_CTFR_ROI_ECH		,
      MSG_JOU_GRD_ROC_ROC_IMP		,
      MSG_JOU_INT_COL_ARR_INV		,
      MSG_JOU_INT_COL_DEP_INV		,
      MSG_JOU_INT_LIG_ARR_INV		,
      MSG_JOU_INT_LIG_DEP_INV		,
      MSG_JOU_PAS_DE_PIE		,
      MSG_JOU_PAS_VOT_TOU		,
      MSG_JOU_PET_ROC_ROC_IMP		,
      MSG_JOU_PIB_2CA_IMP		,
      MSG_JOU_PIB_ARR_OCC		,
      MSG_JOU_PIB_INT_OCC		,
      MSG_JOU_PIB_MVT_IMP		,
      MSG_JOU_PIB_PAS_PIE_PRI		,
      MSG_JOU_PIN_2CA_IMP		,
      MSG_JOU_PIN_MVT_IMP		,
      MSG_JOU_PIO_PIE_PRO_INV		,
      MSG_JOU_PIO_ROI_ECH		,
      MSG_JOU_POS_REP_P3F		,
      MSG_JOU_PRI_PRO_CAM		,
      MSG_JOU_ROI_GRD_ROC_IMP		,
      MSG_JOU_ROI_PET_ROC_IMP		,
      MSG_JOU_ROI_ROI_ECH		,
      MSG_MVT_CAV_MVT_IMP		,
      MSG_MVT_FOU_MVT_IMP		,
      MSG_MVT_FOU_SAU_PIE		,
      MSG_MVT_REI_MVT_IMP		,
      MSG_MVT_REI_SAU_PIE		,
      MSG_MVT_ROI_MVT_IMP		,
      MSG_MVT_TOU_MVT_IMP		,
      MSG_MVT_TOU_SAU_PIE		,
      MSG_PAS_COU_PRE			,
      MSG_RST_DSK_ERR_DON		,
      MSG_RST_DSK_ERR_FIC		,
      MSG_SAV_DSK_ERR_FIC		,
      MSG_SIMU_HST_SIZ			,
      MSG_SIMU_MAT_BLANC		,
      MSG_SIMU_MAT_NOIR			,
      MSG_SIMU_PAT_BLANC		,
      MSG_SIMU_PAT_NOIR			,
      MSG_TYP_LIB_CAV			,
      MSG_TYP_LIB_REI			,
      MSG_VER_AFF_NOT_IMP		,
      MSG_VER_CHO_PRO_PIO		,
      MSG_NBR  	
};
